Index: c/src/libmisc/error/error.c
===================================================================
--- c/src/libmisc/error/error.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/libmisc/error/error.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,9 +1,8 @@
 /*
- *	@(#)error.c	1.2 - 95/08/02
+ *	@(#)error.c	1.6 - 95/12/12
  *	
  *
- * report errors and panics to RTEMS' stderr.
- * Currently just used by RTEMS monitor.
- *
+ *  report errors and panics to RTEMS' stderr.
+ *  Currently just used by RTEMS monitor.
  *
  *  $Id$
@@ -98,5 +97,5 @@
 
 
-char *
+const char *
 rtems_status_text(
     rtems_status_code status
@@ -109,5 +108,5 @@
 static int rtems_verror(
     unsigned32   error_flag,
-    char        *printf_format,
+    const char   *printf_format,
     va_list      arglist
 )
@@ -182,5 +181,5 @@
 int rtems_error(
     int   error_flag,
-    char *printf_format,
+    const char *printf_format,
     ...
   )
@@ -201,5 +200,5 @@
 
 void rtems_panic(
-    char *printf_format,
+    const char *printf_format,
     ...
   )
Index: c/src/libmisc/error/error.h
===================================================================
--- c/src/libmisc/error/error.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/libmisc/error/error.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,5 @@
+
 /*
- *	@(#)error.h	1.1 - 95/08/02
+ *	@(#)error.h	1.3 - 95/10/25
  *	
  *
@@ -7,4 +8,7 @@
  *  $Id$
  */
+
+#ifndef __RTEMS_ERROR_h
+#define __RTEMS_ERROR_h
 
 /*
@@ -19,8 +23,10 @@
                              RTEMS_ERROR_PANIC) /* all */
 
-char *rtems_status_text(rtems_status_code);
-int   rtems_error(int error_code, char *printf_format, ...);
-void  rtems_panic(char *printf_format, ...);
+const char *rtems_status_text(rtems_status_code);
+int   rtems_error(int error_code, const char *printf_format, ...);
+void  rtems_panic(const char *printf_format, ...);
 
 extern int rtems_panic_in_progress;
 
+#endif
+/* end of include file */
Index: c/src/libmisc/monitor/mon-monitor.c
===================================================================
--- c/src/libmisc/monitor/mon-monitor.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/libmisc/monitor/mon-monitor.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,6 @@
 /*
- *	@(#)monitor.c	1.18 - 95/08/02
+ *	@(#)monitor.c	1.22 - 95/11/02
  *	
+ *
  *
  * RTEMS monitor main body
@@ -18,4 +19,8 @@
  *      remote request/response stuff should be cleaned up
  *         maybe we can use real rpc??
+ *      'info' commadn to print out:
+ *           interrupt stack location, direction and size
+ *           floating point config stuff
+ *           interrupt config stuff
  *
  *  $Id$
@@ -228,5 +233,5 @@
       "  A continue from the debugger will return to the monitor.\n",
       0,
-      CPU_INVOKE_DEBUGGER,
+      rtems_monitor_debugger_cmd,
       0,
     },
@@ -297,4 +302,16 @@
 }
 
+void
+rtems_monitor_debugger_cmd(
+    int        argc,
+    char     **argv,
+    unsigned32 command_arg,
+    boolean    verbose
+)
+{
+#ifdef CPU_INVOKE_DEBUGGER
+    CPU_INVOKE_DEBUGGER;
+#endif
+}
 
 void
@@ -339,20 +356,12 @@
  *              400a7090 ? _Configuration_Table
  *
- *
  *      We ignore the type field.
- *
- *  Parameters:
- *
- *
- *  Returns:
- *
  *
  *  Side Effects:
  *      Creates and fills in 'rtems_monitor_symbols' table
  *
- *  Notes:
- *
- *
- *  Deficiencies/ToDo:
+ *  TODO
+ *      there should be a BSP #define or something like that
+ *         to do this;  Assuming stdio is crazy.
  *      Someday this should know BFD
  *              Maybe we could get objcopy to just copy the symbol areas
@@ -374,5 +383,5 @@
         return;
 
-#ifdef simhppa
+#ifdef SIMHPPA
     fp = fdopen(8, "r");                /* don't ask; don't tell */
 #else
Index: c/src/libmisc/monitor/mon-prmisc.c
===================================================================
--- c/src/libmisc/monitor/mon-prmisc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/libmisc/monitor/mon-prmisc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -71,5 +71,5 @@
     unsigned32 b;
     unsigned32 length = 0;
-    char *name;
+    const char *name;
 
     for (b = 1; b; b <<= 1)
Index: c/src/libmisc/monitor/monitor.h
===================================================================
--- c/src/libmisc/monitor/monitor.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/libmisc/monitor/monitor.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,6 @@
 /*
- *      @(#)monitor.h	1.14 - 95/08/02
+ *      @(#)monitor.h	1.20 - 95/12/12
  *      
+ *
  *  $Id$
  */
@@ -319,4 +320,5 @@
 void    rtems_monitor_fatal_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_continue_cmd(int, char **, unsigned32, boolean);
+void    rtems_monitor_debugger_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_node_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_symbols_loadup(void);
Index: c/src/tests/support/include/tmacros.h
===================================================================
--- c/src/tests/support/include/tmacros.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/tests/support/include/tmacros.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -22,6 +22,5 @@
 #endif
 
-#include <rtems.h>
-#include <bsp.h>
+#include <bsp.h>    /* includes <rtems.h> */
 
 #include <stdio.h>
@@ -41,21 +40,27 @@
 
 #define fatal_directive_status( stat, desired, msg ) \
-     { \
+     do { \
        if ( (stat) != (desired) ) { \
          printf( "\n%s FAILED -- expected (%d) got (%d)\n", \
                  (msg), (desired), (stat) ); \
+         fflush(stdout); \
          exit( stat ); \
        } \
-     }
+     } while ( 0 ) 
 
 #define sprint_time(str,s1,tb,s2) \
+  do { \
     sprintf( (str), "%s%02d:%02d:%02d   %02d/%02d/%04d%s", \
        s1, (tb)->hour, (tb)->minute, (tb)->second, \
-       (tb)->month, (tb)->day, (tb)->year, s2 );
+       (tb)->month, (tb)->day, (tb)->year, s2 ); \
+  } while ( 0 )
 
 #define print_time(s1,tb,s2) \
+  do { \
     printf( "%s%02d:%02d:%02d   %02d/%02d/%04d%s", \
        s1, (tb)->hour, (tb)->minute, (tb)->second, \
-       (tb)->month, (tb)->day, (tb)->year, s2 );
+       (tb)->month, (tb)->day, (tb)->year, s2 ); \
+    fflush(stdout); \
+  } while ( 0 )
 
 #define put_dot( c ) putchar( c ); fflush( stdout )
Index: c/src/tests/tools/generic/difftest
===================================================================
--- c/src/tests/tools/generic/difftest	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/tests/tools/generic/difftest	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -56,5 +56,5 @@
     esac
 done
-((shiftcount = $OPTIND - 1))
+shiftcount=`expr $OPTIND - 1`
 shift $shiftcount
 
Index: cpukit/libcsupport/include/rtems/assoc.h
===================================================================
--- cpukit/libcsupport/include/rtems/assoc.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/include/rtems/assoc.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,4 @@
 /*
- *	@(#)assoc.h	1.2 - 95/06/28
+ *	@(#)assoc.h	1.4 - 95/10/25
  *	
  *
@@ -14,5 +14,5 @@
 
 typedef struct {
-    char *name;
+    const char   *name;
     unsigned32   local_value;
     unsigned32   remote_value;
@@ -25,19 +25,19 @@
 #define RTEMS_ASSOC_DEFAULT_NAME "(default)"
 
-rtems_assoc_t *rtems_assoc_ptr_by_name(rtems_assoc_t *, char *);
-rtems_assoc_t *rtems_assoc_ptr_by_value(rtems_assoc_t *, unsigned32);
-rtems_assoc_t *rtems_assoc_ptr_by_remote(rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_name(const rtems_assoc_t *, const char *);
+const rtems_assoc_t *rtems_assoc_ptr_by_value(const rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_local_by_remote(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_remote_by_name(rtems_assoc_t *, char *);
-unsigned32   rtems_assoc_local_by_name(rtems_assoc_t *, char *);
-char        *rtems_assoc_name_by_local(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_remote(rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_local(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_local_by_remote(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_name(const rtems_assoc_t *, const char *);
+unsigned32   rtems_assoc_local_by_name(const rtems_assoc_t *, const char *);
+const char  *rtems_assoc_name_by_local(const rtems_assoc_t *, unsigned32);
+const char  *rtems_assoc_name_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local_bitfield(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_local_bitfield(rtems_assoc_t *, unsigned32, char *);
-char        *rtems_assoc_name_by_remote_bitfield(rtems_assoc_t *, unsigned32, char *);
-unsigned32   rtems_assoc_local_by_remote_bitfield(rtems_assoc_t *ap, unsigned32);
+unsigned32   rtems_assoc_remote_by_local_bitfield(const rtems_assoc_t *, unsigned32);
+char  *rtems_assoc_name_by_local_bitfield(const rtems_assoc_t *, unsigned32, char *);
+char  *rtems_assoc_name_by_remote_bitfield(const rtems_assoc_t *, unsigned32, char *);
+unsigned32   rtems_assoc_local_by_remote_bitfield(const rtems_assoc_t *, unsigned32);
 
 
Index: cpukit/libcsupport/include/rtems/error.h
===================================================================
--- cpukit/libcsupport/include/rtems/error.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/include/rtems/error.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,5 @@
+
 /*
- *	@(#)error.h	1.1 - 95/08/02
+ *	@(#)error.h	1.3 - 95/10/25
  *	
  *
@@ -7,4 +8,7 @@
  *  $Id$
  */
+
+#ifndef __RTEMS_ERROR_h
+#define __RTEMS_ERROR_h
 
 /*
@@ -19,8 +23,10 @@
                              RTEMS_ERROR_PANIC) /* all */
 
-char *rtems_status_text(rtems_status_code);
-int   rtems_error(int error_code, char *printf_format, ...);
-void  rtems_panic(char *printf_format, ...);
+const char *rtems_status_text(rtems_status_code);
+int   rtems_error(int error_code, const char *printf_format, ...);
+void  rtems_panic(const char *printf_format, ...);
 
 extern int rtems_panic_in_progress;
 
+#endif
+/* end of include file */
Index: cpukit/libcsupport/include/rtems/libcsupport.h
===================================================================
--- cpukit/libcsupport/include/rtems/libcsupport.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/include/rtems/libcsupport.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -30,5 +30,8 @@
 );
 
+extern void malloc_dump(void);
 extern void libc_init(int reentrant);
+extern int  host_errno(void);
+extern void fix_syscall_errno(void);
 
 #ifdef __cplusplus
@@ -36,7 +39,4 @@
 #endif
 
-extern int  host_errno(void);
-extern void fix_syscall_errno(void);
-
 #endif
 /* end of include file */
Index: cpukit/libcsupport/src/assoc.c
===================================================================
--- cpukit/libcsupport/src/assoc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/src/assoc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,5 @@
 /*
- *	@(#)assoc.c	1.4 - 95/08/02
- *	
+ *	@(#)assoc.c	1.6 - 95/10/25
+ *
  *
  * assoc.c
@@ -9,5 +9,4 @@
  */
 
-
 #include <rtems.h>
 #include "assoc.h"
@@ -19,11 +18,11 @@
 #define rtems_assoc_is_default(ap)  ((ap)->name && STREQ(ap->name, RTEMS_ASSOC_DEFAULT_NAME))
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_name(
-    rtems_assoc_t *ap,
-    char *name
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    const char *name
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -37,11 +36,11 @@
 }
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -56,11 +55,11 @@
 
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -81,9 +80,9 @@
 unsigned32
 rtems_assoc_remote_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_local(ap, local_value);
     if (nap)
@@ -95,9 +94,9 @@
 unsigned32
 rtems_assoc_local_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_remote(ap, remote_value);
     if (nap)
@@ -109,9 +108,9 @@
 unsigned32
 rtems_assoc_remote_by_name(
-    rtems_assoc_t *ap,
-    char          *name
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    const char          *name
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_name(ap, name);
     if (nap)
@@ -123,9 +122,9 @@
 unsigned32
 rtems_assoc_local_by_name(
-    rtems_assoc_t *ap,
-    char          *name
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    const char          *name
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_name(ap, name);
     if (nap)
@@ -140,23 +139,27 @@
  */
 
-char *
+const char *
 rtems_assoc_name_bad(
     unsigned32 bad_value
 )
 {
+#ifdef RTEMS_DEBUG
     static char bad_buffer[32];
 
     sprintf(bad_buffer, "< %d [0x%x] >", bad_value, bad_value);
+#else
+    static char bad_buffer[32] = "<assoc.c: BAD NAME>";
+#endif
     return bad_buffer;
 }
 
 
-char *
+const char *
 rtems_assoc_name_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_local(ap, local_value);
     if (nap)
@@ -166,11 +169,11 @@
 }
 
-char *
+const char *
 rtems_assoc_name_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_remote(ap, remote_value);
     if (nap)
@@ -186,5 +189,5 @@
 
 unsigned32 rtems_assoc_remote_by_local_bitfield(
-    rtems_assoc_t *ap,
+    const rtems_assoc_t *ap,
     unsigned32     local_value
   )
@@ -202,5 +205,5 @@
 
 unsigned32 rtems_assoc_local_by_remote_bitfield(
-    rtems_assoc_t *ap,
+    const rtems_assoc_t *ap,
     unsigned32     remote_value
   )
@@ -216,6 +219,7 @@
 }
 
-char *rtems_assoc_name_by_remote_bitfield(
-    rtems_assoc_t *ap,
+char *
+rtems_assoc_name_by_remote_bitfield(
+    const rtems_assoc_t *ap,
     unsigned32     value,
     char          *buffer
@@ -237,6 +241,7 @@
 }
 
-char *rtems_assoc_name_by_local_bitfield(
-    rtems_assoc_t *ap,
+char *
+rtems_assoc_name_by_local_bitfield(
+    const rtems_assoc_t *ap,
     unsigned32     value,
     char          *buffer
Index: cpukit/libcsupport/src/error.c
===================================================================
--- cpukit/libcsupport/src/error.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/src/error.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,9 +1,8 @@
 /*
- *	@(#)error.c	1.2 - 95/08/02
+ *	@(#)error.c	1.6 - 95/12/12
  *	
  *
- * report errors and panics to RTEMS' stderr.
- * Currently just used by RTEMS monitor.
- *
+ *  report errors and panics to RTEMS' stderr.
+ *  Currently just used by RTEMS monitor.
  *
  *  $Id$
@@ -98,5 +97,5 @@
 
 
-char *
+const char *
 rtems_status_text(
     rtems_status_code status
@@ -109,5 +108,5 @@
 static int rtems_verror(
     unsigned32   error_flag,
-    char        *printf_format,
+    const char   *printf_format,
     va_list      arglist
 )
@@ -182,5 +181,5 @@
 int rtems_error(
     int   error_flag,
-    char *printf_format,
+    const char *printf_format,
     ...
   )
@@ -201,5 +200,5 @@
 
 void rtems_panic(
-    char *printf_format,
+    const char *printf_format,
     ...
   )
Index: cpukit/libcsupport/src/libio.c
===================================================================
--- cpukit/libcsupport/src/libio.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/src/libio.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -16,5 +16,5 @@
 #include <stdio.h>                      /* O_RDONLY, et.al. */
 #include <fcntl.h>                      /* O_RDONLY, et.al. */
-#include <sys/fcntl.h>                      /* O_RDONLY, et.al. */
+
 #if defined(solaris2)
 #define O_NDELAY O_NONBLOCK
@@ -22,4 +22,5 @@
 #define O_NDELAY _FNBIO
 #endif
+
 #include <errno.h>
 #include <string.h>                     /* strcmp */
@@ -209,5 +210,5 @@
             rc = rtems_semaphore_create(
               RTEMS_LIBIO_IOP_SEM(iop - rtems_libio_iops),
-              1, 
+              1,
               RTEMS_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
               RTEMS_NO_PRIORITY,
Index: cpukit/libcsupport/src/no_libc.c
===================================================================
--- cpukit/libcsupport/src/no_libc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libcsupport/src/no_libc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,3 +1,3 @@
-#if  !defined(RTEMS_LIBC) && !defined(RTEMS_NEWLIB) && !defined(RTEMS_UNIX)
+#if  !defined(RTEMS_NEWLIB) && !defined(RTEMS_UNIX)
 
 /*  no_libc.h
Index: cpukit/libmisc/monitor/mon-monitor.c
===================================================================
--- cpukit/libmisc/monitor/mon-monitor.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libmisc/monitor/mon-monitor.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,6 @@
 /*
- *	@(#)monitor.c	1.18 - 95/08/02
+ *	@(#)monitor.c	1.22 - 95/11/02
  *	
+ *
  *
  * RTEMS monitor main body
@@ -18,4 +19,8 @@
  *      remote request/response stuff should be cleaned up
  *         maybe we can use real rpc??
+ *      'info' commadn to print out:
+ *           interrupt stack location, direction and size
+ *           floating point config stuff
+ *           interrupt config stuff
  *
  *  $Id$
@@ -228,5 +233,5 @@
       "  A continue from the debugger will return to the monitor.\n",
       0,
-      CPU_INVOKE_DEBUGGER,
+      rtems_monitor_debugger_cmd,
       0,
     },
@@ -297,4 +302,16 @@
 }
 
+void
+rtems_monitor_debugger_cmd(
+    int        argc,
+    char     **argv,
+    unsigned32 command_arg,
+    boolean    verbose
+)
+{
+#ifdef CPU_INVOKE_DEBUGGER
+    CPU_INVOKE_DEBUGGER;
+#endif
+}
 
 void
@@ -339,20 +356,12 @@
  *              400a7090 ? _Configuration_Table
  *
- *
  *      We ignore the type field.
- *
- *  Parameters:
- *
- *
- *  Returns:
- *
  *
  *  Side Effects:
  *      Creates and fills in 'rtems_monitor_symbols' table
  *
- *  Notes:
- *
- *
- *  Deficiencies/ToDo:
+ *  TODO
+ *      there should be a BSP #define or something like that
+ *         to do this;  Assuming stdio is crazy.
  *      Someday this should know BFD
  *              Maybe we could get objcopy to just copy the symbol areas
@@ -374,5 +383,5 @@
         return;
 
-#ifdef simhppa
+#ifdef SIMHPPA
     fp = fdopen(8, "r");                /* don't ask; don't tell */
 #else
Index: cpukit/libmisc/monitor/mon-prmisc.c
===================================================================
--- cpukit/libmisc/monitor/mon-prmisc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libmisc/monitor/mon-prmisc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -71,5 +71,5 @@
     unsigned32 b;
     unsigned32 length = 0;
-    char *name;
+    const char *name;
 
     for (b = 1; b; b <<= 1)
Index: cpukit/libmisc/monitor/monitor.h
===================================================================
--- cpukit/libmisc/monitor/monitor.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/libmisc/monitor/monitor.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,6 @@
 /*
- *      @(#)monitor.h	1.14 - 95/08/02
+ *      @(#)monitor.h	1.20 - 95/12/12
  *      
+ *
  *  $Id$
  */
@@ -319,4 +320,5 @@
 void    rtems_monitor_fatal_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_continue_cmd(int, char **, unsigned32, boolean);
+void    rtems_monitor_debugger_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_node_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_symbols_loadup(void);
Index: cpukit/rtems/include/rtems/rtems/types.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/types.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/rtems/include/rtems/rtems/types.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -34,10 +34,16 @@
 typedef unsigned16      rtems_unsigned16; /* unsigned 16-bit value */
 typedef unsigned32      rtems_unsigned32; /* unsigned 32-bit value */
-typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 
 typedef signed8         rtems_signed8;    /* signed 8-bit value  */
 typedef signed16        rtems_signed16;   /* signed 16-bit value */
 typedef signed32        rtems_signed32;   /* signed 32-bit value */
+
+/*
+ * some C++ compilers (eg: HP's) don't do 'long long'
+ */
+#if defined(__GNUC__)
+typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 typedef signed64        rtems_signed64;   /* signed 64-bit value */
+#endif
 
 typedef single_precision rtems_single;    /* single precision float */
Index: cpukit/score/cpu/hppa1.1/cpu.c
===================================================================
--- cpukit/score/cpu/hppa1.1/cpu.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/score/cpu/hppa1.1/cpu.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -25,27 +25,14 @@
 void hppa_external_interrupt_disable(unsigned32);
 void hppa_external_interrupt(unsigned32, CPU_Interrupt_frame *);
-
-/*
- * Our interrupt handlers take a 2nd argument:
- *   a pointer to a CPU_Interrupt_frame
- * So we use our own prototype instead of rtems_isr_entry
- */
-
-typedef void ( *hppa_rtems_isr_entry )(
-    ISR_Vector_number,
-    CPU_Interrupt_frame *
- );
-
-
-/*
- * who are we?  cpu number
- * Not used by executive proper, just kept (or not) as a convenience
- * for libcpu and libbsp stuff that wants it.
- *
- * Defaults to 0.  If the BSP doesn't like it, it can change it.
- */
-
-int cpu_number;                 /* from 0; cpu number in a multi cpu system */
-
+void hppa_cpu_halt(unsigned32);
+
+/*
+ * The first level interrupt handler for first 32 interrupts/traps.
+ * Indexed by vector; generally each entry is _Generic_ISR_Handler.
+ * Some TLB traps may have their own first level handler.
+ */
+
+extern void _Generic_ISR_Handler(void);
+unsigned32 HPPA_first_level_interrupt_handler[HPPA_INTERNAL_INTERRUPTS];
 
 /*  _CPU_Initialize
@@ -87,4 +74,18 @@
 
     /*
+     * Init the first level interrupt handlers
+     */
+
+    for (i=0; i <= HPPA_INTERNAL_INTERRUPTS; i++)
+        HPPA_first_level_interrupt_handler[i] = (unsigned32) _Generic_ISR_Handler;
+
+    /*
+     * Init the 2nd level interrupt handlers
+     */
+
+    for (i=0; i <= CPU_INTERRUPT_NUMBER_OF_VECTORS; i++)
+        _ISR_Vector_table[i] = (ISR_Handler_entry) hppa_cpu_halt;
+
+    /*
      * Stabilize the interrupt stuff
      */
@@ -97,4 +98,31 @@
 
     iva_table = (unsigned32) IVA_Table;
+#if defined(hppa1_1)
+    /*
+     * HACK:  (from PA72000 TRM, page 4-19)
+     * "The hardware TLB miss handler will never attempt to service
+     *  a non-access TLB miss or a TLB protection violation.  It
+     *  will only attempt to service TLB accesses that would cause
+     *  Trap Numbers 6 (Instruction TLB miss) and 15 (Data TLB miss)."
+     *
+     * The LPA instruction is used to translate a virtual address to
+     * a physical address, however, if the requested virtual address
+     * is not currently resident in the TLB, the hardware TLB miss
+     * handler will NOT insert it.  In this situation Trap Number
+     * #17 is invoked (Non-access Data TLB miss fault).
+     *
+     * To work around this, a dummy data access is first performed
+     * to the virtual address prior to the LPA.  The dummy access
+     * causes the TLB entry to be inserted (if not already present)
+     * and then the following LPA instruction will not generate
+     * a non-access data TLB miss fault.
+     *
+     * It is unclear whether or not this behaves the same way for
+     * the PA8000.
+     * 
+     */
+    iva = *(volatile unsigned32 *)iva_table;  /* dummy access */
+#endif
+
     HPPA_ASM_LPA(0, iva_table, iva);
     set_iva(iva);
@@ -113,6 +141,6 @@
     HPPA_ASM_SSM(0, level);	/* change no bits; just get copy */
     if (level & HPPA_PSW_I)
-        return 1;
-    return 0;
+        return 0;
+    return 1;
 }
 
@@ -185,10 +213,6 @@
  *
  *  TODO:
- *    delete interrupt.c etc.
  *    Count interrupts
  *    make sure interrupts disabled properly
- *    should handler check again for more interrupts before exit?
- *    How to enable interrupts from an interrupt handler?
- *    Make sure there is an entry for everything in ISR_Vector_Table
  */
 
@@ -209,14 +233,12 @@
 
     /* mark them all unused */
-
     DISABLE(~0);
     DISMISS(~0);
 
     /* install the external interrupt handler */
-  _CPU_ISR_install_vector(
-    HPPA_INTERRUPT_EXTERNAL_INTERRUPT,
-    (proc_ptr)hppa_external_interrupt,
-    &ignore
-  );
+    _CPU_ISR_install_vector(
+        HPPA_INTERRUPT_EXTERNAL_INTERRUPT,
+	(proc_ptr)hppa_external_interrupt, &ignore
+);
 }
 
@@ -257,17 +279,19 @@
        vector, iframe->Interrupt.pcoqfront);
 */
-    DISMISS(VECTOR_TO_MASK(vector));
-    DISABLE(VECTOR_TO_MASK(vector));
-}
-
-void
-hppa_external_interrupt_report_spurious(unsigned32           spurious,
+}
+
+void
+hppa_external_interrupt_report_spurious(unsigned32           spurious_mask,
                                         CPU_Interrupt_frame *iframe)
 {
     int v;
     for (v=0; v < HPPA_EXTERNAL_INTERRUPTS; v++)
-        if (VECTOR_TO_MASK(v) & spurious)
+        if (VECTOR_TO_MASK(v) & spurious_mask)
+        {
+            DISMISS(VECTOR_TO_MASK(v));
+            DISABLE(VECTOR_TO_MASK(v));
             hppa_external_interrupt_spurious_handler(v, iframe);
-    DISMISS(spurious);
+        }
+    DISMISS(spurious_mask);
 }
 
@@ -305,5 +329,5 @@
                 DISMISS(m);
                 mask &= ~m;
-                (*handler)(global_vector, iframe);
+                handler(global_vector, iframe);
             }
         }
@@ -311,10 +335,10 @@
         if (mask != 0) {
             if ( _CPU_Table.spurious_handler )
-              (*((hppa_rtems_isr_entry) _CPU_Table.spurious_handler))(
-                  mask,
-                  iframe
-                );
+            {
+                handler = (hppa_rtems_isr_entry) _CPU_Table.spurious_handler;
+                handler(mask, iframe);
+            }
             else
-              hppa_external_interrupt_report_spurious(mask, iframe);
+                hppa_external_interrupt_report_spurious(mask, iframe);
         }
     }
@@ -331,6 +355,5 @@
 
 void
-hppa_cpu_halt(unsigned32 type_of_halt,
-              unsigned32 the_error)
+hppa_cpu_halt(unsigned32 the_error)
 {
     unsigned32 isrlevel;
@@ -338,5 +361,5 @@
     _CPU_ISR_Disable(isrlevel);
 
-    asm volatile( "copy %0,%%r1" : : "r" (the_error) );
+    HPPA_ASM_LABEL("_hppa_cpu_halt");
     HPPA_ASM_BREAK(1, 0);
 }
Index: cpukit/score/cpu/unix/cpu.c
===================================================================
--- cpukit/score/cpu/unix/cpu.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/score/cpu/unix/cpu.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -88,5 +88,5 @@
 
   sigemptyset(&posix_empty_mask);
- 
+
   /*
    * Block all the signals except SIGTRAP for the debugger
@@ -603,5 +603,4 @@
   extern boolean     _Context_Switch_necessary;
 
-
   if (_ISR_Nest_level++ == 0) {
       /* switch to interrupt stack */
@@ -636,17 +635,32 @@
 void _CPU_Stray_signal(int sig_num)
 {
-  char buffer[ 4 ];   
-
-  /* 
-   *  We avoid using the stdio section of the library.
-   *  The following is generally safe.
-   */
-
-  buffer[ 0 ] = (sig_num >> 4) + 0x30;
-  buffer[ 1 ] = (sig_num & 0xf) + 0x30;
-  buffer[ 2 ] = '\n';
-
-  write( 2, "Stray signal 0x", 12 );
-  write( 2, buffer, 3 );
+  char buffer[ 4 ];
+ 
+  /*
+   * print "stray" msg about ones which that might mean something
+   * Avoid using the stdio section of the library.
+   * The following is generally safe.
+   */
+ 
+  switch (sig_num)
+  {
+      case SIGCLD:
+          break;
+ 
+      default:
+      {
+          /*
+           *  We avoid using the stdio section of the library.
+           *  The following is generally safe.
+           */
+ 
+          buffer[ 0 ] = (sig_num >> 4) + 0x30;
+          buffer[ 1 ] = (sig_num & 0xf) + 0x30;
+          buffer[ 2 ] = '\n';
+ 
+          write( 2, "Stray signal 0x", 12 );
+          write( 2, buffer, 3 );
+      }
+  }
  
   /*
Index: cpukit/score/include/rtems/system.h
===================================================================
--- cpukit/score/include/rtems/system.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/score/include/rtems/system.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -57,12 +57,13 @@
 
 #ifdef USE_INLINES
-#define STATIC static
-#define INLINE __inline__
+# define STATIC static
+# ifdef __GNUC__
+#  define INLINE __inline__
+# else
+#  define INLINE inline
+# endif
 #else
-/*
-#error Only the GNU C compiler is currently supported!!!
-*/
-#define STATIC
-#define INLINE
+# define STATIC
+# define INLINE
 #endif
 
Index: cpukit/score/inline/rtems/score/address.inl
===================================================================
--- cpukit/score/inline/rtems/score/address.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/score/inline/rtems/score/address.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -59,5 +59,5 @@
 )
 {
-  return (left - right);
+  return ((char *) left - (char *) right);
 }
 
Index: cpukit/score/inline/rtems/score/coremsg.inl
===================================================================
--- cpukit/score/inline/rtems/score/coremsg.inl	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ cpukit/score/inline/rtems/score/coremsg.inl	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -18,4 +18,6 @@
 #define __CORE_MESSAGE_QUEUE_inl
 
+#include <string.h>   /* needed for memcpy */
+ 
 /*PAGE
  *
